Bug 862325 - Fact modification improperly cancels activations
Fact modification improperly cancels activations
Product: JBoss Enterprise BRMS Platform 5
Classification: JBoss
Component: BRE (Expert, Fusion) (Show other bugs)
BRMS 5.3.0.GA
All All
unspecified Severity urgent
: ER4
: BRMS 5.3.1 GA
Assigned To: Edson Tirelli
Marek Winkler
Depends On:
  Show dependency treegraph
Reported: 2012-10-02 12:04 EDT by Edson Tirelli
Modified: 2014-10-26 21:14 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
An optimization engine bug occurred when the first rule to fire in a session modified a fact that had activations pending. Accordingly, rules that depended on the modified fact were no longer firing. This has been resolved by removing the particular optimization for the engine that is no longer relevant to the new algorithms, and the rules now properly fire.
Story Points: ---
Clone Of:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Edson Tirelli 2012-10-02 12:04:15 EDT
Description of problem:
If the first rule to fire in a session modifies a fact, the engine improperly cancels pending activations depending on that fact.

Version-Release number of selected component (if applicable):

How reproducible:
A test case where the first rule to fire modifies a fact that previously activated other rules.

Actual results:
Activations improperly cancelled

Expected results:
Activations are not cancelled and fire properly.

Additional info:
This was raised by a partner. The actual details/rules are confidential and shared under NDA. I am opening this ticket for the partner.
Comment 1 Edson Tirelli 2012-10-02 12:05:41 EDT
This bug occurs only in a very specific scenario, but it is very critical as it silently fails causing the engine to produce wrong results.
Comment 2 Edson Tirelli 2012-10-15 20:19:41 EDT
Fix backported to 5.3.x.
Comment 3 Edson Tirelli 2012-10-31 11:55:58 EDT
The test case to reproduce and verify this problem is committed here:


Please note that the scenario is very specific, so even changing the order of the updates on the consequence will prevent the bug from showing up.
Comment 4 Douglas Hoffman 2012-11-05 19:58:40 EST
I have updated the Doc Text for documentation Release Notes.
Thank you for the information.

- Doug
Comment 5 Marek Winkler 2012-11-12 06:26:42 EST
Verified on 5.3.1.BRMS-ER4.

Note You need to log in before you can comment on or make changes to this bug.